#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Orange
#property indicator_color3 Black

extern string TimeFrame = "H1";
extern int RsiPeriod = 4;
extern int MaType = 1;
extern int MaPeriod = 2;
extern bool Interpolate = TRUE;
extern string arrowsIdentifier = "Arrows";
extern color arrowsUpColor = Lime;
extern color arrowsDnColor = Red;
extern bool alertsOn = TRUE;
extern bool alertsSound = TRUE;
extern bool alertsOnCurrent = FALSE;
extern bool alertsMessage = FALSE;
extern bool alertsEmail = FALSE;
double globda_136[];
double globda_140[];
double globda_144[];
string globs_148;
bool globi_156 = FALSE;
bool globi_160 = FALSE;
int globi_164;
string globs_nothing_168 = "nothing";
datetime globt_176;

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   IndicatorBuffers(3);
   SetIndexBuffer(0, globda_136);
   SetIndexLabel(0, "rsi");
   SetIndexBuffer(1, globda_140);
   SetIndexLabel(1, "ema");
   SetIndexBuffer(2, globda_144);
   SetIndexLabel(2, "trend");
   if (TimeFrame == "calculate") {
      globi_156 = TRUE;
      return (0);
   }
   if (TimeFrame == "returnBars") {
      globi_160 = TRUE;
      return (0);
   }
   globi_164 = f0_3(TimeFrame);
   globs_148 = WindowExpertName();
   IndicatorShortName(" killbinarysignals " + f0_0());
   return (0);
}
				 	     		 		  	  	 	  	    	 	  	 			  		  	  	  		 		  						   			  	 			 		 	    	 	   		 		 	  	  				   	  		 	  	  			  	 				  			   	 			    			  		 	   	  			      
// 52D46093050F38C27267BCE42543EF60
int deinit() {
   f0_2();
   return (0);
}
	 	   	 		  		 					  						 				  			 	 	  								       		  	   	   						        		  			 	 		 									 	 	 	  		 						   						  				 			  		 			 	 	  	 		  	  	   		 		 	
// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   int locli_12;
   int locli_16;
   double locld_24;
   int locli_36;
   int locli_0 = IndicatorCounted();
   if (locli_0 < 0) return (-1);
   if (locli_0 > 0) locli_0--;
   int locli_8 = MathMin(Bars - locli_0, Bars - 1);
   if (globi_160) {
      globda_136[0] = locli_8 + 1;
      return (0);
   }
   if (globi_164 > Period()) locli_8 = MathMax(locli_8, MathMin(Bars - 1, iCustom(NULL, globi_164, globs_148, "returnBars", 0, 0) * globi_164 / Period()));
   if (globi_156) {
      for (int locli_4 = 0; locli_4 < locli_8; locli_4++) globda_136[locli_4] = iRSI(NULL, 0, RsiPeriod, PRICE_CLOSE, locli_4);
      for (locli_4 = 0; locli_4 < locli_8; locli_4++) globda_140[locli_4] = iMAOnArray(globda_136, 0, MaPeriod, 0, MaType, locli_4);
      return (0);
   }
   for (locli_4 = locli_8; locli_4 >= 0; locli_4--) {
      locli_12 = iBarShift(NULL, globi_164, Time[locli_4]);
      globda_136[locli_4] = iCustom(NULL, globi_164, globs_148, "calculate", RsiPeriod, MaType, MaPeriod, 0, locli_12);
      globda_140[locli_4] = iCustom(NULL, globi_164, globs_148, "calculate", RsiPeriod, MaType, MaPeriod, 1, locli_12);
      globda_144[locli_4] = globda_144[locli_4 + 1];
      if (globda_136[locli_4] > globda_140[locli_4]) globda_144[locli_4] = 1;
      if (globda_136[locli_4] < globda_140[locli_4]) globda_144[locli_4] = -1;
      if (globda_144[locli_4] != globda_144[locli_4 + 1]) {
         if (globda_144[locli_4] == 1.0) f0_1(locli_4, arrowsUpColor, 233, 0);
         if (globda_144[locli_4] == -1.0) f0_1(locli_4, arrowsDnColor, 234, 1);
      }
      if (globi_164 <= Period() || locli_12 == iBarShift(NULL, globi_164, Time[locli_4 - 1])) continue;
      if (Interpolate) {
         locli_16 = iTime(NULL, globi_164, locli_12);
         for (int locli_20 = 1; locli_4 + locli_20 < Bars && Time[locli_4 + locli_20] >= locli_16; locli_20++) {
         }
         locld_24 = 1.0 / locli_20;
         for (int locli_32 = 1; locli_32 < locli_20; locli_32++) {
            globda_136[locli_4 + locli_32] = locli_32 * locld_24 * (globda_136[locli_4 + locli_20]) + (1.0 - locli_32 * locld_24) * globda_136[locli_4];
            globda_140[locli_4 + locli_32] = locli_32 * locld_24 * (globda_140[locli_4 + locli_20]) + (1.0 - locli_32 * locld_24) * globda_140[locli_4];
         }
      }
   }
   if (alertsOn) {
      if (alertsOnCurrent) locli_36 = 0;
      else locli_36 = 1;
      if (globda_144[locli_36] != globda_144[locli_36 + 1]) {
         if (globda_144[locli_36] == 1.0) f0_4("up");
         if (globda_144[locli_36] == -1.0) f0_4("down");
      }
   }
   return (0);
}
		  	  		 	  		 	  		   	  			  				 		   	  	  	  		 		 			  	  				 	 	  	  		 		 		 	   				 		 	 	  	      					    	  		 	 	  	  	 	    	 	     	 			  			 					  	 	 			 		
// 8D889266138297DD92247DFDC01E6723
void f0_1(int argmi_0, color argmi_4, int argmi_8, bool argmi_12) {
   string locls_16 = arrowsIdentifier + ":" + Time[argmi_0];
   double locld_24 = 3.0 * iATR(NULL, 0, 20, argmi_0) / 4.0;
   ObjectCreate(locls_16, OBJ_ARROW, 0, Time[argmi_0], 0);
   ObjectSet(locls_16, OBJPROP_ARROWCODE, argmi_8);
   ObjectSet(locls_16, OBJPROP_COLOR, argmi_4);
   if (argmi_12) {
      ObjectSet(locls_16, OBJPROP_PRICE1, High[argmi_0] + locld_24);
      return;
   }
   ObjectSet(locls_16, OBJPROP_PRICE1, Low[argmi_0] - locld_24);
}
	 				 	 	 	  	  		 		   		 	         	 		 	     		 					    		 	   			  		  				  		  				 	 	   	      			 	 	     	   		 			  		  		  			   					   	  			 	     		 		 	 	  	 
// B4CC322FC1B58ED8264BB2FA751F8C0A
void f0_2() {
   string locls_16;
   string locls_0 = arrowsIdentifier + ":";
   int locli_8 = StringLen(locls_0);
   for (int locli_12 = ObjectsTotal() - 1; locli_12 >= 0; locli_12--) {
      locls_16 = ObjectName(locli_12);
      if (StringSubstr(locls_16, 0, locli_8) == locls_0) ObjectDelete(locls_16);
   }
}
	  									    		  			 		  	 	 	 	      			  	 		  		 	  	  	    	 		  		   	 	  			 		 	  	   	     	 		 	 				 	  		 		  		  		   	  		 	  		 	 	  			  		   	 	 				    	 			
// DA717D55A7C333716E8D000540764674
void f0_4(string argms_0) {
   string locls_8;
   if (globs_nothing_168 != argms_0 || globt_176 != Time[0]) {
      globs_nothing_168 = argms_0;
      globt_176 = Time[0];
      locls_8 = StringConcatenate(Symbol(), " at ", TimeToStr(TimeLocal(), TIME_SECONDS), " RSI crossed EMA ", argms_0);
      if (alertsMessage) Alert(locls_8);
      if (alertsEmail) SendMail(StringConcatenate(Symbol(), "RsiEma"), locls_8);
      if (alertsSound) PlaySound("alert2.wav");
   }
}
	   	   			  					 		  			 			 		 		 			 		  	 			 		 	   		  		  			 				 	  	   	 		   	 						  	 	 			      	 		   			 		 				 	  				   	   	   	  	   					 			      			  	
// B9EDCDEA151586E355292E7EA9BE516E
int f0_3(string argms_0) {
   int locli_12;
   for (int locli_8 = StringLen(argms_0) - 1; locli_8 >= 0; locli_8--) {
      locli_12 = StringGetChar(argms_0, locli_8);
      if ((locli_12 > '`' && locli_12 < '{') || (locli_12 > '' && locli_12 < 256)) argms_0 = StringSetChar(argms_0, locli_8, locli_12 - 32);
      else
         if (locli_12 > -33 && locli_12 < 0) argms_0 = StringSetChar(argms_0, locli_8, locli_12 + 224);
   }
   int locli_16 = 0;
   if (argms_0 == "M1" || argms_0 == "1") locli_16 = 1;
   if (argms_0 == "M5" || argms_0 == "5") locli_16 = 5;
   if (argms_0 == "M15" || argms_0 == "15") locli_16 = 15;
   if (argms_0 == "M30" || argms_0 == "30") locli_16 = 30;
   if (argms_0 == "H1" || argms_0 == "60") locli_16 = 60;
   if (argms_0 == "H4" || argms_0 == "240") locli_16 = 240;
   if (argms_0 == "D1" || argms_0 == "1440") locli_16 = 1440;
   if (argms_0 == "W1" || argms_0 == "10080") locli_16 = 10080;
   if (argms_0 == "MN" || argms_0 == "43200") locli_16 = 43200;
   if (locli_16 == 0 || locli_16 < Period()) locli_16 = Period();
   return (locli_16);
}
	   	 					  	  		 		 	 		 				 	 		 	   		  		 		 		  	  		      			   		 	   	  	 				 	 			  	  	 		 		    			 		  	 		 		   		 	    		   			 	   				   		  	 			 		   						
// 114D6A415B3D04DB792CA7C0DA0C7A55
string f0_0() {
   switch (globi_164) {
   case PERIOD_M1:
      return ("M(1)");
   case PERIOD_M5:
      return ("M(5)");
   case PERIOD_M15:
      return ("M(15)");
   case PERIOD_M30:
      return ("M(30)");
   case PERIOD_H1:
      return ("H(1)");
   case PERIOD_H4:
      return ("H(4)");
   case PERIOD_D1:
      return ("D(1)");
   case PERIOD_W1:
      return ("W(1)");
   case PERIOD_MN1:
      return ("MN(1)");
   }
   return ("Unknown timeframe");
}